#include <stdio.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>		/* socket, sockaddr, ... */
#include <netdb.h>		/* gethostbyaddr */
#include <netinet/in.h>
#include <errno.h>		/* perror */
#include <unistd.h>
#include <fcntl.h>

#include "misc.h"

const char *httprequest = "GET /teplota.txt\n";

int helium_http_get_actual_value(char *therm, cfg *helium_cfg)
{
    struct sockaddr_in srv_addr;
    int sockfd;

    int i;
    char rbuf[80];
    int d,mo,y,h,m,s;
    float temp;

    if ((sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
	strcpy(therm, "N/A");
	return -1;
    };

    bzero((char *) &srv_addr, sizeof(srv_addr));
    srv_addr.sin_family = AF_INET;
    srv_addr.sin_port = htons(helium_cfg->serverport);	/* HTTP service */
    srv_addr.sin_addr.s_addr = (ulong) inet_addr(helium_cfg->server);
    i = connect(sockfd, (struct sockaddr *) &srv_addr, sizeof(srv_addr));

    if (i < 0) {
	strcpy(therm, "N/A");
	return -1;
    }

    write(sockfd, httprequest, strlen(httprequest));

    i = read(sockfd, rbuf, 79);
    rbuf[i] = 0;
    if (sscanf(rbuf, "%d.%d.%d, %d:%d:%d, %f", &d, &mo, &y, &h, &m, &s, &temp) == 7) {
	sprintf(therm, "%3.1f", temp);
    } else {
	strcpy(therm, "N/A");
    }
    
    close(sockfd);
    return 0;

};
