#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>		/* socket, sockaddr, ... */
#include <netdb.h>		/* gethostbyaddr */
#include <netinet/in.h>
#include <errno.h>		/* perror */
#include <unistd.h>
#include <fcntl.h>
#include "misc.h"

#define F_STRING "__LIN_0.10"

int helium_udp_get_actual_value(char *therm, cfg *helium_cfg)
{
    struct sockaddr_in cli_addr, srv_addr;
    int sockfd;
    struct hostent *hp;
    int i, len, from_length;
    char sbuf[80], rbuf[80];
    struct timeval tv;
    fd_set rfds;
    int selval;

    if ((sockfd = socket(PF_INET, SOCK_DGRAM, 0)) < 0) {
	printf("Socket nelze otevrit");
	strcpy(therm, "N/A");
	return -1;
    };

    if (-1 == fcntl(sockfd, F_SETFL, O_NONBLOCK)) {
	printf("Nelze nastavit soket\n");
	strcpy(therm, "N/A");
	return -1;
    };

    bzero((char *) &cli_addr, sizeof(cli_addr));
    cli_addr.sin_family = AF_INET;
    cli_addr.sin_addr.s_addr = INADDR_ANY;
    cli_addr.sin_port = 0;	/* nejake cislo portu bude prideleno */

    if (bind(sockfd, (struct sockaddr *) &cli_addr, sizeof(cli_addr)) < 0) {
	close(sockfd);
	printf("Chyba v bind");
	strcpy(therm, "N/A");
	return -1;
    };

    bzero((char *) &srv_addr, sizeof(srv_addr));
    srv_addr.sin_family = AF_INET;
    srv_addr.sin_port = htons(helium_cfg->serverport);	/* ECHO service */
    srv_addr.sin_addr.s_addr = (ulong) inet_addr(helium_cfg->server);

    strcpy(sbuf, F_STRING);
    len = strlen(sbuf);

    if ((i =
	 sendto(sockfd, sbuf, len, 0, &srv_addr, sizeof(srv_addr))) < 0) {
	close(sockfd);
	strcpy(therm, "N/A");
	return -1;
    };

    FD_ZERO(&rfds);
    FD_SET(sockfd, &rfds);
    tv.tv_sec = 30;
    tv.tv_usec = 100;
    if (!(selval = select(sockfd + 1, &rfds, NULL, NULL, &tv))) {
	strcpy(therm, "N/A");
	return -1;
    };

    if ((i =
	 recvfrom(sockfd, rbuf, sizeof(rbuf), 0, &srv_addr,
		  &from_length)) < 0) {
	close(sockfd);
	strcpy(therm, "N/A");
	return -1;
    };


    rbuf[i] = '\x0';
    strcpy(therm, rbuf);
    close(sockfd);
    return 0;

};
